import java.net.*;
import java.io.*;
import java.util.Vector;
import java.util.Enumeration;

public class ServidorHilo extends Thread{
    private Socket cliente = null;
    private DataInputStream entrada = null;
    private DataOutputStream salida = null;
    private static Vector conectados = new Vector();
    private String nick;
    
    //  El constructor establece los flujos de entrada/salida cone el cliente   
    
    public ServidorHilo(Socket cliente) throws IOException{
    	super(new String(cliente.getInetAddress().toString()));
	this.cliente=cliente;
	entrada = new DataInputStream(new BufferedInputStream(cliente.getInputStream()));
	salida = new DataOutputStream(new BufferedOutputStream(cliente.getOutputStream()));
    }
	
    public void run(){
	try{
            boolean n=true;
            do{
                nick = new String(entrada.readUTF());// Quien se quiere conectar?
		ServidorHilo ni = buscarnick(nick); // Veamos si el apodo existe
                /* buscarnick retorna el objeto ServidorHilo en el cual ya tenemos
                 * al apodo (almacenado en nick) ya conectado o null caso contrario */ 
		if(ni!=null) transmitir("/n",this); // ya tenemos alguien as...

                  /* Ya tenemos alguien as apodado, entonces los parmetros a 
                   * transmitir son el mensaje "/n" y un objeto ServidorHilo null.
                   * Con ello transmitir activa comportamiento del cliente que 
                   * hace la correspondiente advertencia...                   */   
		else n=false;
            }while(n);  //  Salimos de este bucle si el apodo (nick) es nuevo
            transmitir(" >> " + nick + " se ha unido al chat.",null);
            transmitir("/c" + nick, null);  // Indicamos la nueva conexion
            conectados.addElement(this);    // Incorporamos en la lista
            transmitir("", this);
            while(true){    //  Ciclo de atencion al cliente
		String ent = new String(entrada.readUTF()); // Que nos envia ?
		if(ent.startsWith("/p")){   //  Control, (msge privado)
                    /* Buscamos el destinatario del mensaje, est inmediatamente
                     * despues de /p, o sea la posicin 2, termina con \t   */
                    String nickdest=ent.substring(2,ent.indexOf("\t"));
                    /* El mensaje est a continuacin del destinatario, o sea 
                     * posicion de "\t" + 1, hasta el fin de la cadena      */
                    String msg=ent.substring(ent.indexOf("\t")+1);
                    // Busquemos al destinatario de ese mensaje privado 
                    ServidorHilo dest=buscarnick(nickdest); 
                    if(dest==null)  // O sorpresa, no existe (Esto no debe ocurrir)
			transmitir(">> No se pudo entregar el mensaje privado a "+nickdest,this);
                    else{           //  Lo tenemos, comuniquemonos con el 
			transmitir("- Privado de "+ nick + ": " + msg, dest);
			transmitir("- Privado para "+ nickdest + ": " + msg, this);
                    }
                    ent="";
		}
		else    // No es un mensaje privado, nos comunicaremos con todos
                    transmitir(nick + ": "+ ent,null);
            }   // while(true)
	}       // try
	catch (IOException e) {;}
	finally{
            conectados.removeElement(this);
            transmitir("/d" + nick,null);
            transmitir(" >> " + nick + " ha dejado el chat.",null);
            System.out.println("Se desconect "+ cliente.getInetAddress());
            try{
		entrada.close();
		salida.close();
		cliente.close();
            }
            catch (IOException e) {;}
	}
    } // public void run
	
    public ServidorHilo buscarnick(String n){

        /* A continuacin vemos un ejemplo de uso de comportamiento de la clase
         * Enumeration. Ya la hemos usado en la U I, la conocemos. Aqu la esta-       
         * mos usando para recorrer la lista de usuarios ya conectados al chat */ 

        Enumeration con = conectados.elements();  
	while(con.hasMoreElements()){
            ServidorHilo cl = (ServidorHilo) con.nextElement();
            if(n.matches(cl.nick)){return cl;}  //  Ya tenemos ese alias (nick)
	}
	return null;    //  El apodo, alias (nick) es nuevo
    }
	
    private static synchronized void transmitir(String mensaje, ServidorHilo sh){
	Enumeration conect = conectados.elements();
        while(conect.hasMoreElements()){
            ServidorHilo ctes = (ServidorHilo) conect.nextElement();
            if(sh==null){   //  
                try{
                    ctes.salida.writeUTF(mensaje);
                    ctes.salida.flush();
                }
                catch (IOException e){ctes.stop();}
            }
            else{
                try{
                    if(mensaje==""){
                        sh.salida.writeUTF("/c"+ ctes.nick);
                        sh.salida.flush();
                    }
                    else{
                        sh.salida.writeUTF(mensaje);
                        sh.salida.flush();
                        break;
                    }
                }   // try
                catch(IOException e){;}
            }   // if((sh==null)
	}   // while(conect.hasMoreElements())
    }   // private static synchronized void transmitir
}   // public class ServidorHilo